/** Classe que emmagatzema totes les caracterstiques comuns
* dels sensors */
public abstract class Sensor
{

		/** Atribut que emmagatzema el codi del sensor **/
	protected	String codi;
		/** Atribut que emmagatzema el preu del sensor **/
	protected	double preu;
		/** Atribut que emmagatzema el sistema de seguretat on es troba
		Si val null s que no est assignat a cap sistema **/
	protected	String sistema;

		/** Constructor amb dos parmetres
		@param cd  Codi del sensor
		@param pr  preu del sensor **/
		public Sensor(String cd, double pr)
		{
			codi=cd;
			preu=pr;
			sistema=null;
		}

		/**Sobrecrrega del constructor per a millorar la simulaci de l'herncia mltiple **/
		public Sensor()
		{
			codi="0";
			preu=0;
			sistema=null;
		}

		/** Accessor d'escriptura de l'atribut sistema
		@param sis	Sistema on pertany el sensor**/
		public void setSistema(String sis)
		{
			sistema=sis;
		}

		/** Accessor d'escriptura de l'atribut codi
		@param c	Codi del sensor**/
		public void setCodi(String c)
		{
			codi=c;
		}

		/** Accessor d'escriptura de l'atribut preu
		@param p	Preu del sensor**/
		public void setPreu(double p)
		{
			preu=p;
		}

		/** Accessor de lectura del codi del sensor
		@return codi del sensor**/
		public String getCodi()
		{
			return codi;
		}

		/** Accessor de lectura del preu del sensor
		@return preu del sensor**/
		public double getPreu()
		{
			return preu;
		}

		/** Accessor de lectura del sistema on es troba el sensor
		@return sistema del sensor**/
		public String getSistema()
		{
			return sistema;
		}

		/** Mtode que comprova si dos sensors sn iguals.
		* Redefineix el mtode equals de la classe Object

		* @param sen un altre objecte de la classe Sensor
		* @return  cert, si ambds sensors tenen el mateix codi i sn no nul; fals, altrament
    	**/
    	public boolean equals(Object sen)
		{
			/* Comprovem que el parmetre i el codi del sensor no siguin null */
			if ( (sen == null) || (getCodi() == null) )  return  false;

			/* Comprovem que el parmetre sigui una instncia de Client */
			if ( ! (sen instanceof Sensor) )  return  false;

			/* Comprovem que els DNI's sn iguals */

			return  getCodi().equals( ((Sensor)sen).getCodi() );
		}

		/** Redefinici del mtode toString de la classe Object
		* @return  Retorna un string amb tota la informaci del sensor **/
		public String toString()
		{
			return("\tCodi: "+getCodi()+"\n\tPreu: "+getPreu()+"\n");
		}
}